// Win32_CPP_List_Test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

// add Win32 headers here
#include <conio.h>
#include <windows.h>

#include <list>
#include <iostream>

using namespace std;


// high resolution timer object
class THighResTimer
{
private:
  LARGE_INTEGER t0,t1,f;
  double et,last_dt;
  bool na;
protected:
public:
  THighResTimer(void)
  {
    QueryPerformanceFrequency(&f);
    na=f.QuadPart==0;
    HighResReset();
  }
  void HighResReset(void)   // reset timer
  {
    QueryPerformanceCounter(&t0);
    last_dt=0.0;
    et=0.0;
  }
  double HighResTime(void)	// elapsed time in seconds
  {
    double dt;

    if (na) return 0.0;

    QueryPerformanceCounter(&t1);
    dt=double(t1.QuadPart-t0.QuadPart);
    if (dt<0.0)
    {
      et=et+last_dt/f.QuadPart;
      t0=t1;
      last_dt=0.0;
      return et;
    }
    else
    {
      last_dt=dt;
      return et+dt/f.QuadPart;
    }
  }
};


int _tmain(int argc, _TCHAR* argv[])
{
#ifdef _DEBUG
  static const int NT=1;
#else
  static const int NT=20;
#endif
  static const int ND=5000;

  using namespace std;

  list <int> list1;
  list <int> list2;
  double t;

  THighResTimer *HRT=new THighResTimer();

  for (int i=0;i<ND;i++)
  {
    list1.push_back(ND-i);
  }

  HRT->HighResReset();
  for (int i=0;i<NT;i++)
  {
    list<int>::iterator itr;
    for( itr = list1.begin(); itr != list1.end(); itr++)
    {
      list2.push_back(*itr);
    }
    list2.clear();
  }
  t=HRT->HighResTime()/NT;
  cout << "STL Add-Clear Time: " << t << "\r\n";

  HRT->HighResReset();
  for (int i=0;i<NT;i++)
  {
    list<int>::iterator itr;
    for( itr = list1.begin(); itr != list1.end(); itr++)
    {
      list2.push_back(*itr);
    }
    list2.sort();
    list2.clear();
  }
  t=HRT->HighResTime()/NT;
  cout << "STL Add-Sort1-Clear Time: " << t << "\r\n";

  HRT->HighResReset();
  for (int i=0;i<NT;i++)
  {
    list<int>::iterator itr = list1.end();
    while (itr != list1.begin())
    {
      itr--;
      list2.push_back(*itr);
    }
    list2.sort();
    list2.clear();
  }
  t=HRT->HighResTime()/NT;
  cout << "STL Add-Sort2-Clear Time: " << t << "\r\n";

  list1.clear();

  cout << "Press any key to exit...";

  _getch();
  
  delete HRT;
  
  return 0;
}

